#include <SPI.h>
#include <Gamebuino.h>
#include "gb_sprite.h"
#include "rot_gb_sprite.h"
#include "sprite_tv.h"
#include "music.h"
Gamebuino gb;

/*
#define NB_BALLS 10

struct _ball {
  int x;
  int y;
  int sz;
  int vx;
  int vy;
};

_ball balls[NB_BALLS];
*/

/* 782 bytes, 230uS. Thx Myndale! */
void drawBitmapUnrolled(int8_t x, int8_t y, const uint8_t *bitmap, const uint8_t color) {
  int8_t h = pgm_read_byte(bitmap + 1);
  const int8_t byteWidth = (pgm_read_byte(bitmap) + 7) >> 3;
  bitmap += 2;   
  uint8_t * screen_line = gb.display.getBuffer() + (y / 8) * LCDWIDTH_NOROT + x;
 
  if (color == BLACK)
  {
    uint8_t mask = _BV(y & 7);
    while (h--)
    {
      uint8_t * ptr = screen_line;
      uint8_t i = byteWidth;
      while (i--)
      {
        const uint8_t pixels = pgm_read_byte(bitmap++);
        if (pixels & 0x80) ptr[0] |= mask;
        if (pixels & 0x40) ptr[1] |= mask;
        if (pixels & 0x20) ptr[2] |= mask;
        if (pixels & 0x10) ptr[3] |= mask;
        if (pixels & 0x08) ptr[4] |= mask;
        if (pixels & 0x04) ptr[5] |= mask;
        if (pixels & 0x02) ptr[6] |= mask;
        if (pixels & 0x01) ptr[7] |= mask;
        ptr += 8;
      }
      y++;
      if (!(y & 7))
        screen_line += LCDWIDTH_NOROT;
      mask = (mask & 0x80) ? 1 : (mask<<1);
    }
  }
 
  else if (color == WHITE)
  {
    uint8_t mask = ~_BV(y & 7);
    while (h--)
    {
      uint8_t * ptr = screen_line;
      uint8_t i = byteWidth;
      while (i--)
      {
        const uint8_t pixels = pgm_read_byte(bitmap++);
        if (pixels & 0x80) ptr[0] &= mask;
        if (pixels & 0x40) ptr[1] &= mask;
        if (pixels & 0x20) ptr[2] &= mask;
        if (pixels & 0x10) ptr[3] &= mask;
        if (pixels & 0x08) ptr[4] &= mask;
        if (pixels & 0x04) ptr[5] &= mask;
        if (pixels & 0x02) ptr[6] &= mask;
        if (pixels & 0x01) ptr[7] &= mask;
        ptr += 8;
      }
      y++;
      if (!(y & 7))
        screen_line += LCDWIDTH_NOROT;
      mask = (mask & 0x80) ? (mask<<1)+1 : 0xfe;
    }
  }
 
  else  // invert
  {
    uint8_t mask = _BV(y & 7);
    while (h--)
    {
      uint8_t * ptr = screen_line;
      uint8_t i = byteWidth;
      while (i--)
      {
        const uint8_t pixels = pgm_read_byte(bitmap++);
        if (pixels & 0x80) ptr[0] ^= mask;
        if (pixels & 0x40) ptr[1] ^= mask;
        if (pixels & 0x20) ptr[2] ^= mask;
        if (pixels & 0x10) ptr[3] ^= mask;
        if (pixels & 0x08) ptr[4] ^= mask;
        if (pixels & 0x04) ptr[5] ^= mask;
        if (pixels & 0x02) ptr[6] ^= mask;
        if (pixels & 0x01) ptr[7] ^= mask;
        ptr += 8;
      }
      y++;
      if (!(y & 7))
        screen_line += LCDWIDTH_NOROT;
      mask = (mask & 0x80) ? 1 : (mask<<1);
    }
  } 
}

/*
void init_balls() {
  int i;
  for(i=0;i<NB_BALLS;i++) {
    balls[i].sz=random(1, 10);
    balls[i].x=random(0,LCDHEIGHT-balls[i].sz);
    balls[i].y=random(0,LCDWIDTH-balls[i].sz);
    balls[i].vx=random(1, 4);
    balls[i].vy=random(1, 4);
    if(random(0,2)==0) balls[i].vx *= -1;
    if(random(0,2)==0) balls[i].vy *= -1;
  }
}

void animate_ball(int i, int play_sound) {
    int x;
    int y;
    int c;

    //add the speed of the ball to its position
    balls[i].x += balls[i].vx;
    balls[i].y += balls[i].vy;
  
  //check that the ball is not going out of the screen
  //if the ball is touching the left side of the screen
  if(balls[i].x < 0){
    //change the direction of the horizontal speed
    balls[i].vx *= -1;
    //play a preset "tick" sound when the ball hits the border
    if(play_sound) gb.sound.playTick();
  }
  //if the ball is touching the right side
  if((balls[i].x + balls[i].sz) > LCDWIDTH){
    balls[i].vx *= -1;
    if(play_sound) gb.sound.playTick();
  }
  //if the ball is touching the top side
  if(balls[i].y < 0){
    balls[i].vy *= -1;
    if(play_sound) gb.sound.playTick();
  }
  //if the ball is touching the down side
  if((balls[i].y + balls[i].sz) > LCDHEIGHT){
    balls[i].vy *= -1;
    if(play_sound) gb.sound.playTick();
  }
  gb.display.setColor(INVERT);
  //draw the ball on the screen
  //gb.display.fillRect(balls[i].x, balls[i].y, balls[i].sz, balls[i].sz);
  for(y=0;y<balls[i].sz;y++) {
    for(x=0;x<balls[i].sz;x++) {
      //too slow
      //drawFilledCircle(balls[i].x+balls[i].sz/2, balls[i].y+balls[i].sz/2, balls[i].sz/2);
      
      //square balls.
      gb.display.drawPixel(balls[i].x+x, balls[i].y+y);
      
    }
  }
}
*/

/*
void invertPixel(int8_t x, int8_t y) {
      gb.display.setColor((gb.display.getPixel(x, y)==WHITE)?BLACK:WHITE);
      gb.display.drawPixel(x, y);
}

void invertCircleEmpty(int8_t x0, int8_t y0, int8_t r) {
    int8_t f = 1 - r;
    int8_t ddF_x = 1;
    int8_t ddF_y = -2 * r;
    int8_t x = 0;
    int8_t y = r;

    invertPixel(x0, y0 + r);
    invertPixel(x0, y0 - r);
    invertPixel(x0 + r, y0);
    invertPixel(x0 - r, y0);

    while (x < y) {
        if (f >= 0) {

            y--;
            ddF_y += 2;
            f += ddF_y;
        }
        x++;
        ddF_x += 2;
        f += ddF_x;

        invertPixel(x0 + x, y0 + y);
        invertPixel(x0 - x, y0 + y);
        invertPixel(x0 + x, y0 - y);
        invertPixel(x0 - x, y0 - y);
        invertPixel(x0 + y, y0 + x);
        invertPixel(x0 - y, y0 + x);
        invertPixel(x0 + y, y0 - x);
        invertPixel(x0 - y, y0 - x);
    }
}


void drawFilledCircle(int8_t x0, int8_t y0, int8_t r) {
for(int y=-r; y<=r; y++)
    for(int x=-r; x<=r; x++)
        if(x*x+y*y <= r*r)
            gb.display.drawPixel(x0+x, y0+y);
}            


void invertFilledCircle(int8_t x0, int8_t y0, int8_t r) {
for(int y=-r; y<=r; y++)
    for(int x=-r; x<=r; x++)
        if(x*x+y*y <= r*r)
            invertPixel(x0+x, y0+y);
}            
*/

void reverse_screen() {
  gb.display.setColor(INVERT);
  int x; int y; int c;
  for(y=0;y<48;y++) {
    for(x=0;x<84;x++) {
      gb.display.drawPixel(x, y);
    }
  }
}

void display_anim() {
  int c=BLACK;
   int step = (gb.frameCount/3) % 72;
   //                       len  from-to   
   //rotating gb: 10 steps*2  20      0-19
   //walking gb:   3 steps*4  12     20-31
   //rotating gb: 10 steps*2  20     32-51
   //anim tv:      5 steps *4 20     52-71
   
   if(step<19) {
     step = step % 10;          
     drawBitmapUnrolled(18,5,rot_gb_sprite[step],c);
   }
   else if(step<=31) {
     step -= 20;
     step = step % 3;
     drawBitmapUnrolled(18,0,sprite_gb[step],c);
   }
   else if(step<=51) {   
     step -= 32;
     step = step % 10;
     drawBitmapUnrolled(18,5,rot_gb_sprite[step],c);
   }
   else if(step<=71) {   
     step -= 52;
     step = step % 5;
     drawBitmapUnrolled(18,10,sprite_tv[step],c);
   }
   
/*
   int skip_balls=0;
   if(step<=7) {
     step = step % 7;
     drawBitmapUnrolled(0,0,bmp[step],c);
   }
   else if(step<=15) {
     step -= 8;
     step = step % 7;
     drawBitmapUnrolled(0,0,bmp[step],c);
   }
   else if(step<=16) {
     drawBitmapUnrolled(0,0,bmpscreen[0],c);
     reverse_screen();
     skip_balls=1;
   }
   else if(step<=22) {
     drawBitmapUnrolled(0,0,bmpscreen[1],c);
     reverse_screen();
     skip_balls=1;
   }
   else if(step<=30) {
     step -= 20;
     step = step % 7;
     drawBitmapUnrolled(0,0,bmp[step],c);
   }
   else if(step<=38) {
     step -= 28;
     step = step % 7;
     drawBitmapUnrolled(0,0,bmp[step],c);
   }
   else if(step<=9999) {
     step -= 37;
     step %= 3;
     drawBitmapUnrolled(0,0,bmpgb[step],c);
     skip_balls=0;
   }
   if (skip_balls==0) {
      int i;   
      for(i=0;i<NB_BALLS;i++) { animate_ball(i, 0); }
   }
*/       
  }

/*
void invertFilledCircle2(int8_t x0, int8_t y0, int8_t r) {
    int x = r;
    int y = 0;
    int xChange = 1 - (r << 1);
    int yChange = 0;
    int radiusError = 0;

    while (x >= y)
    {
        for (int i = x0 - x; i <= x0 + x; i++)
        {
            invertPixel(i, y0 + y);
            invertPixel(i, y0 - y);
        }
        for (int i = x0 - y; i <= x0 + y; i++)
        {
            invertPixel(i, y0 + x);
            invertPixel(i, y0 - x);
        }

        y++;
        radiusError += yChange;
        yChange += 2;
        if (((radiusError << 1) + xChange) > 0)
        {
            x--;
            radiusError += xChange;
            xChange += 2;
        }
    }
}
*/

void setup(){
  gb.begin();
  gb.pickRandomSeed();
  //init_balls();

  gb.titleScreen(F("The Other Days Music demo"));
  gb.frameCount = LCDWIDTH*8;
  gb.setFrameRate(30);
  for(byte i=0; i<NUM_CHANNELS; i++){
      gb.sound.changePatternSet(patternSet,i);
      gb.sound.changeInstrumentSet(instrumentSet,i);
  }
  gb.sound.playTrack(track1,0);
  gb.sound.playTrack(track2,1);
  gb.sound.playTrack(track3,2);
  gb.sound.playTrack(track4,3);
  gb.sound.command(CMD_INSTRUMENT, 1, 0, 3);
}

void loop(){  
  if(gb.update()){
  display_anim();
/*
    int i;
    for(i=0;i<NB_BALLS;i++) {
      animate_ball(i, 0);    
    } //for each ball
*/

    //display some fancy stuff
    gb.display.cursorX = -gb.frameCount/2;
    gb.display.cursorY = LCDHEIGHT-6;
    gb.display.print("a song called Buino :) - Code: The Other Days + Rodot");
     
    int8_t l=8;
    int8_t h=(LCDHEIGHT-8)/8;
    int8_t p=1;
    int8_t tsz=8; //text size

    if(gb.sound.trackIsPlaying[0]){
      gb.display.setColor(INVERT);      
      
      l=l-p;
      gb.display.fillRect(0*l+0*p, LCDHEIGHT-tsz, l, -gb.sound.outputVolume[0]*h);
      gb.display.fillRect(1*l+1*p, LCDHEIGHT-tsz, l, -gb.sound.outputVolume[1]*h);
      gb.display.fillRect(LCDWIDTH-2*l-1*p, LCDHEIGHT-tsz, l, -gb.sound.outputVolume[2]*h);
      gb.display.fillRect(LCDWIDTH-1*l-0*p, LCDHEIGHT-tsz, l, -gb.sound.outputVolume[3]*h);
    }
    else {
      gb.display.cursorX = 26;
      gb.display.cursorY = 20;
      gb.display.print("THANKS!");
      gb.display.cursorY = 26;
      gb.display.cursorX = 12;
      gb.display.print("TheOtherDays.net");
      gb.display.cursorX = 12;
      gb.display.cursorY = 36;
      gb.display.print("PRESS C TO EXIT");
    }
    
    if(gb.buttons.pressed(BTN_C)){
      gb.sound.stopTrack();
      gb.titleScreen(F("The Other Days Music demo"));
      gb.sound.playTrack(track2,0);
      gb.sound.playTrack(track1,1);
      gb.sound.playTrack(track3,2);
      gb.sound.playTrack(track4,3);
    }
  }
}
